"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var rand_1 = require("../rand");
var times_1 = require("../times");
var process_1 = require("../process");
var IGNORED_INPUT_TAILS = [","];
var TAIL_PROBABILITIES = {
    "!": 0.1,
    "?": 0.09,
    o: 0.07,
    u: 0.06
};
// prettier-ignore
var LENGTHS = [
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3,
    4, 4, 4,
    5, 5,
    6,
    7,
    8,
    9,
    10,
    11,
    12
];
exports.repeat = function (input) {
    if (process_1.isProcessedWord(input)) {
        var _a = input.slice().reverse(), tail_1 = _a[0], rest = _a.slice(1);
        if (IGNORED_INPUT_TAILS.includes(tail_1.source)) {
            return input;
        }
        if (Math.random() > (TAIL_PROBABILITIES[tail_1.source] || 0)) {
            return input;
        }
        return rest.concat([
            __assign({}, tail_1, { transformed: times_1.times(rand_1.sample(LENGTHS), function () { return tail_1.source; }).concat(tail_1.transformed) })
        ]);
    }
    return input;
};
