import { ProcessedCharacter } from "./process";
import { Stream } from "./humanize";
export interface StrokedCharacter {
    character: ProcessedCharacter;
    pause: number;
}
export declare type StrokedStream = StrokedCharacter[];
export interface GenerateStrokedStream {
    stream: Stream;
    pauseMin?: number;
    pauseMax?: number;
}
export declare const generateStrokedStream: ({ stream, pauseMin, pauseMax }: GenerateStrokedStream) => StrokedCharacter[];
export interface SimulateTyping extends GenerateStrokedStream {
    onStroke({ stroke, strokedStream }: {
        stroke: StrokedCharacter;
        strokedStream: StrokedStream;
    }): void | Promise<any>;
}
export declare const simulateTyping: ({ stream, onStroke, pauseMin, pauseMax }: SimulateTyping) => Promise<any[]>;
export declare const toString: (strokedStream: StrokedCharacter[]) => string;
