"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rand_1 = require("./rand");
var isPromise = function (val) {
    return val && val.then !== undefined;
};
exports.generateStrokedStream = function (_a) {
    var stream = _a.stream, _b = _a.pauseMin, pauseMin = _b === void 0 ? 15 : _b, _c = _a.pauseMax, pauseMax = _c === void 0 ? 250 : _c;
    return [].concat.apply([], stream.map(function (word, i) { return word.map(function (character) { return ({
        character: character,
        pause: rand_1.range(pauseMin, pauseMax)
    }); }).concat((stream.length - 1 === i
        ? []
        : [
            {
                character: {
                    source: " ",
                    transformed: [" "]
                },
                pause: rand_1.range(pauseMin, pauseMax)
            }
        ])); }));
};
exports.simulateTyping = function (_a) {
    var stream = _a.stream, onStroke = _a.onStroke, _b = _a.pauseMin, pauseMin = _b === void 0 ? 15 : _b, _c = _a.pauseMax, pauseMax = _c === void 0 ? 250 : _c;
    return exports.generateStrokedStream({ stream: stream, pauseMin: pauseMin, pauseMax: pauseMax }).reduce(function (promise, stroke) {
        return promise.then(function (prevStroke) {
            var nextStream = prevStroke.concat([stroke]);
            return new Promise(function (resolve) {
                var maybePromise = onStroke({
                    stroke: stroke,
                    strokedStream: nextStream
                });
                if (isPromise(maybePromise)) {
                    return maybePromise.then(function () { return resolve(nextStream); });
                }
                // Or we just set a timeout for the pause of the stroke.
                setTimeout(function () {
                    resolve(nextStream);
                }, stroke.pause);
            });
        });
    }, Promise.resolve([]));
};
exports.toString = function (strokedStream) {
    return strokedStream.map(function (_a) {
        var character = _a.character;
        return character.transformed.join("");
    }).join("");
};
