"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rand_1 = require("./rand");
var process_1 = require("./process");
var simulate_1 = require("./simulate");
describe("simulate", function () {
    describe("#generateStrokes", function () {
        beforeAll(function () { return rand_1.initRand("seed"); });
        test("generates a score of strokes", function () {
            expect(simulate_1.generateStrokedStream({ stream: process_1.process("hello world") })).toStrictEqual([
                { character: { source: "h", transformed: ["h"] }, pause: 148 },
                { character: { source: "e", transformed: ["e"] }, pause: 213 },
                { character: { source: "l", transformed: ["l"] }, pause: 50 },
                { character: { source: "l", transformed: ["l"] }, pause: 142 },
                { character: { source: "o", transformed: ["o"] }, pause: 243 },
                { character: { source: " ", transformed: [" "] }, pause: 57 },
                { character: { source: "w", transformed: ["w"] }, pause: 143 },
                { character: { source: "o", transformed: ["o"] }, pause: 20 },
                { character: { source: "r", transformed: ["r"] }, pause: 183 },
                { character: { source: "l", transformed: ["l"] }, pause: 225 },
                { character: { source: "d", transformed: ["d"] }, pause: 89 }
            ]);
        });
    });
});
